       78 ProcessItem              value '"' & ProgramID
                                             & 'ProcessItem"' & x"00".
       78 ScrollingList            value '"' & ProgramID
                                             & 'VerticalScroll"'
                                             & x"00".

      * TO DO: if wanted - set to 1, initial generated version is 0
       01 ListViewIcons            PIC X comp-5 value 1.
          88 IconsWanted           value 1.

      * TO DO: if wanted - set to 1, initial generated version is 0
       01 ItemCheckBoxes           PIC X comp-5 value 0.
          88 CheckBoxesWanted           value 1.

      * TO DO: Set up your own resourceDLL if required, tailor these
      * items to meet your resources.
       01 ResourceDLL              PIC X(20)
                                  value "lview.dll" & X"00".
       78 numberOfImages           value 50.
      *> se si varia variare anche nel vmenu00 BASEBMAP.
       78 BaseResID                value 200.

       01 aControl                 object reference value null.
       01 aListViewItem            object reference value null.
       01 aListView                object reference value null.
       01 aCollection              object reference value null.
       01 aResource                object reference value null.
       01 anIcon                   object reference value null.
       01 normalImageList          object reference value null.
       01 smallImageList           object reference value null.

      * TO DO: If all data is placed in group at outset set this to zero
      * A value of 1 enables tracking of scroll position in the list
       01 Data-state               PIC X comp-5 value 0.
          88 Paging-Data           value 1.

      * The Keycodes
        copy "Keys.cpy".
       01 Keystroke                K-KEYDESC.
       01 KeyFlags                 pic x(4) comp-5.
       01 keysMask                 pic x(4) comp-5.
       01 keysState                pic x(4) comp-5.

       01 aGadgetHWND              Pic 9(9) comp-5.
       01 aNextFocusHWND           Pic 9(9) comp-5.
       01 aBool                    pic 99 comp-5 value 0.
          88 aBool-True            VALUE 1.
       01 x                        pic x(4) comp-5.
       01 y                        pic x(4) comp-5.
       01 w                        pic x(4) comp-5.
       01 h                        pic x(4) comp-5.

       01 colorDlg                 object reference value null.
       01 colorObject              object reference value null.
       01 lnkred                   pic 99 comp-5.
       01 lnkGreen                 pic 99 comp-5.
       01 lnkBlue                  pic 99 comp-5.

       01 text-Width               pic x(4) comp-5.
       01 text-height              pic x(4) comp-5.
       01 pointSize                pic x(4) comp-5.
       01 AttributeFlags           pic x(4) comp-5.
       01 ResourceID               pic x(4) comp-5.

       01 itemCBState              PIC X comp-5.
       01 NumColumns               PIC X comp-5.
       01 NumColumns-x4            PIC X(4) comp-5.
       01 ncol                     PIC X(4) comp-5.
       01 comodo                   PIC 9.
       01 aClass                   object reference.
      * This file details the GUI class library event codes
        copy "p2cevent.cpy".
      *
        copy "parg".
       01 COMODI.
          05 FNTENV    PIC X(60).
      *
       01 lung      Pic X(4)   comp-5.
       01 BUFFER    Pic X(8192000).
       01 ix        pic x(4)   comp-5.
       01 jx        pic x(4)   comp-5.
       01 TAB       PIC X      VALUE X'09'.
       01 lx        pic x(4)   comp-5.
       01 cx        pic x(4)   comp-5.
       01 flgsegno  pic x.
       01 sx        pic x(4)   comp-5.
       01 nlines    pic x(4)   comp-5.
       01 titoli    pic x(100) occurs 100.
       01 lnkFieldId            pic x(4) comp-5.
       01 lsField1              usage object reference.
       01 aControl-lines           object reference value null.
       01 comodox   pic x(100).
        copy "parelv".
        copy "parxp".
       local-storage section.

      * Although no local-storage is used, this section is needed to
      * allow EntryCallback based recursive calls to the entry points
      * of this program.
      *
       01 RIGA4 PIC X(60).
       linkage section.

      * The object reference of the object receiving an event for
      * which a callback will be defined
       01 anEvent              usage object reference.

      * This file defines the interface for integration of this
      * control with the Dialog System runtime
        copy "userctrl.cpy".
      *
        copy "lview.cpy".

       PROCEDURE DIVISION USING Data-Block.

      *  Convert the lv-Call-Function to Uppercase
         MOVE LENGTH OF lv-Call-Function TO Function-Length
         CALL "CBL_TOUPPER" USING lv-Call-Function
                          BY VALUE Function-Length

          SET aControl TO lv-Object-Reference

         MOVE lv-iconswanted TO ListViewIcons
         EVALUATE lv-Call-Function
      **** rel 7.1
          WHEN "COPIA-LINEA"
               PERFORM scrivi-clipbrd-line thru ex-scrivi-clipbrd-line
          WHEN "COPIA-TUTTO"
               PERFORM scrivi-clipbrd      thru ex-scrivi-clipbrd
          WHEN "INI-ESPORTA"
               PERFORM ini-esporta         thru ex-ini-esporta
          WHEN "ESPORTA"
               PERFORM esporta             thru ex-esporta
      ************
          WHEN "ADD-HEADER"
               *> Input: The datablock lview-item group containing each
               *>        columns header text and its length
               PERFORM Add-List-Header
               PERFORM colora-List
      *
      **** rel 7.1
          WHEN "UPDATE-HEADER"
               PERFORM Update-List-Header
      ************

          WHEN "CLEAR-OBJECT"
               *> Input: lv-Object-Reference set to the ListView itself
               INVOKE aControl "deleteAll"

          WHEN "DELETE-LIST-ITEM"
               *> Input : See GetOrValidateObject section
               PERFORM GetOrValidateObject
               INVOKE lv-object-reference "finalize"
                                     RETURNING lv-object-reference
               SET lv-object-reference TO aControl

          WHEN "GET-CHECK-BOX-STATE"
               *> Input : See GetOrValidateObject section
               *> Output: lv-Numeric-Value2 = 0/1 unselected/selected
               PERFORM GetOrValidateObject
               INVOKE lv-Object-Reference "getCheckBoxValue"
                                                         RETURNING aBool
               MOVE aBool TO lv-Numeric-Value2

          WHEN "SET-CHECK-BOX-STATE"
               *> Input : See GetOrValidateObject section
               PERFORM GetOrValidateObject
               IF lv-Numeric-Value2 = 0
                  INVOKE lv-Object-Reference "unselectCheckBox"
               ELSE
                  INVOKE lv-Object-Reference "selectCheckBox"
                  INVOKE lv-Object-reference "makeVisible"
               END-IF

          WHEN "GET-LIST-ITEM-STATE"
               *> Input : See GetOrValidateObject section
               *> Output: lv-Numeric-Value2 = 0/1 unselected/selected
               PERFORM GetOrValidateObject
               INVOKE lv-Object-Reference "isSelected" RETURNING aBool
               MOVE aBool TO lv-Numeric-Value2


          WHEN "SET-LIST-ITEM-STATE"
               *> Input : See GetOrValidateObject section
               PERFORM GetOrValidateObject
               IF lv-Numeric-Value2 = 0
                  INVOKE lv-Object-Reference "setUnselected"
               ELSE
                  *> Item Focus Not always required For multiple
                  *> selection lists, in which case use:
                  *> INVOKE lv-Object-Reference "setSelected"
                  INVOKE lv-Object-Reference "setSelectedWithFocus"
                  INVOKE lv-Object-reference "makeVisible"
               END-IF
      *> da tenere altrimenti non aggiorna i dati correttamente poich 
      *> perdo lv-Numeric-Value
                  MOVE ProcessItem TO MessageName
                  INVOKE EntryCallback "new" USING MessageName
                                         RETURNING aCallback
                  INVOKE aControl "selectedItems" returning aCollection
                  MOVE 34591  TO Event-Type
                 INVOKE aCollection "do" using aCallback
                 INVOKE aCallback "Finalize" RETURNING aCallback
      *

          WHEN "GET-SELECTED-LIST-ITEM"
               *> Input : lv-Object-Reference = ListView itself
               *>         lv-Numeric-Value = Search startpoint
               *> Output: lv-Object-Reference = next selected ListViewItem
               *>         lv-Numeric-Value2 = index of next selected ListViewItem
               INVOKE aControl "nextSelectedItem" USING lv-Numeric-Value
                                          RETURNING lv-Object-Reference
               INVOKE aControl "indexOf" USING lv-Object-Reference
                                     RETURNING lv-Numeric-Value2


          WHEN "GET-TOP-LIST-ITEM"
               *> Input : lv-Object-Reference = ListView itself
               *> Output: lv-Object-Reference = Top visible ListViewItem
               *>         lv-Numeric-Value = index of that item
               INVOKE aControl "getListViewTopItem"
                                         RETURNING lv-Numeric-Value
               PERFORM GetOrValidateObject

          WHEN "SET-TOP-LIST-ITEM"
               *> Input : See GetOrValidateObject section
               PERFORM GetOrValidateObject
               INVOKE aControl "setListViewTopItem" 
                                    USING lv-Numeric-Value


          WHEN "INSERT-LIST-ITEM"
               *> Input: lv-Object-Reference = listview itself
               *>        The datablock lview-item group containing a
               *>        single rows' columns text
               *>        lv-Numeric-Value = optional item icon index
               MOVE lvData-Icon TO lv-Numeric-Value
               PERFORM Insert-Item

      *   WHEN "INSERT-MANY-LIST-ITEMS"
      *        *> Input: lv-Object-Reference = listview itself
      *        *>        The datablock lview-data group containing
      *        *>        multiple row and columns text
      *        *>        lvData-Max = the number of items to insert
      *        PERFORM Insert-Many-Items

          WHEN "MOVE-DOWN-LIST"
               *> Input : lv-Object-Reference = ListView itself
               *>         lv-Numeric-Value = Number of items to scroll down
               INVOKE aControl "moveDownList" USING lv-Numeric-Value

          WHEN "MOVE-UP-LIST"
               *> Input : lv-Object-Reference = ListView itself
               *>         lv-Numeric-Value = Number of items to scroll up
               INVOKE aControl "moveUpList"   USING lv-Numeric-Value


          WHEN "RETRIEVE-LIST-ITEM"
               *> Input : See GetOrValidateObject section
               *> Output: Lview-Item datablock group populated with all
               *>         text in the list columns for this listviewitem
               PERFORM GetOrValidateObject
               INVOKE aControl "numberOfColumns" RETURNING NumColumns
               PERFORM VARYING i FROM 1 BY 1 UNTIL i > NumColumns
                  INVOKE lv-Object-Reference "getColumnValue" USING i
                                                    RETURNING aCharArray
                  INVOKE aCharArray "getValueWithSize"
                                                  USING lvItem-Length(i)
                                              RETURNING lvItem-Text(i)
               END-PERFORM

          WHEN "SET-FONT"
               *> Input : lv-IO-Text-Buffer = the Face Name
               *>         lv-Numeric-Value = font point size
               *>         lv-Numeric-Value2 = Attribute flags (from bit
               *>         settings defined in FONT.CPY)
               MOVE lv-Numeric-Value  TO pointSize
               MOVE lv-Numeric-Value2 TO AttributeFlags
               PERFORM Set-Font-Function

          WHEN "UPDATE-LIST-ITEM"
               *> Input : See GetOrValidateObject section AND
               *>         LVIEW-ITEM datablock group provides new data
               *>         for the columns for this listviewitem
               PERFORM GetOrValidateObject
               INVOKE aControl "numberOfColumns" RETURNING NumColumns
               PERFORM VARYING k FROM 1 BY 1 UNTIL k > NumColumns
                   MOVE lvItem-Text(k) TO Term-Field
                   PERFORM Null-Terminate-Routine
                   INVOKE lv-Object-Reference "setColumnValueZ" USING k
                                                             Term-Field
               END-PERFORM
               IF IconsWanted
                  MOVE lvData-Icon TO lv-Numeric-Value
                  INVOKE lv-Object-Reference "setImageIndex" USING
                         lv-Numeric-Value
               END-IF
               IF lv-column-order NOT = ZERO
                  move lv-column-order to ncol
                  move 1               to comodo
                  INVOKE aControl "sortOnColumn" USING ncol comodo

         WHEN "SET-FOCUS"

      *        setFocus on the object Instance, this uses the
      *        AbstractWindow Class method for this control

      *        Note that invoking this method, and having this program
      *        with an entryCallback for this event requires existence
      *        of a a local-storage section to allow recursion, even
      *        though no data may be used.

              INVOKE lv-Object-Reference "setFocus"
      *
          WHEN "COLORA-LISTVIEW"
               PERFORM colora-List

          WHEN "SET-COLOR"
               *> Input: lv-Object-Reference = listview itself
               *>        Note: an alternative is to use the color class
               *>        methods to retrieve an object, rather than this
               *>        color dialog.
               INVOKE aControl "getAncestor" RETURNING aWindow
               INVOKE colordialog "new" using aWindow
                                    returning colorDlg

               INVOKE colorDlg "create"
               INVOKE colorDlg "getcolor" returning colorObject
               INVOKE colorDlg "finalize" returning colorDlg

               IF colorObject NOT = NULL
                  INVOKE colorObject "getRGB" using lnkred
                                                    lnkgreen
                                                    lnkblue

                  INVOKE aListview "setbackgroundcolor"
                                                       USING colorObject
                  INVOKE aListView "invalidate"
                  INVOKE colorObject "finalize" RETURNING colorObject
               END-IF

          WHEN "SORT"
              perform riordina thru ex-riordina

          WHEN OTHER
              DISPLAY Invalid-Function, " ", lv-Call-Function
              GO TO List-Program-Exit

          END-EVALUATE
          .

       List-Program-Exit.

          EXIT PROGRAM.

      *>----------------------------------------------------------------
       Create-Entry-Point Section.
       Entry "C" & ProgramID USING EntryPoint-Data.


      * Do the create having been passed the Panels2 Session ID, the
      * parent window handle, the co-ordinates for the creation of the
      * control and the datablock master field associated with this control.

          MOVE EntryPanels-Session-ID TO Queue-ID
          MOVE EntryWindow-Data     TO aHwnd
          PERFORM GetWindow-Instance-Routine

          INVOKE ListView "new" using aWindow
                           returning aControl

          INVOKE aControl "SortHeader"
      *   Create the control, nothing will be painted until the
      *   class library system event loop is resumed
          INVOKE aControl "create"
          INVOKE aControl "setRectangle" USING EntryPosition-X
                                               EntryPosition-Y
                                               EntrySize-Width
                                               EntrySize-Height

      ****TO DO: Set this to the initial type and settings required,
      *   ReportView gives a column header for the list
      *   INVOKE aControl "DisplayReportView"
          INVOKE aControl "SingleSelection"
          INVOKE aControl "ShowSelectionAlways"
      *
      * se non si vuole le intestazioni delle colonne
      *   INVOKE aControl "NoColumnHeader"
          INVOKE aControl "ColumnHeader"
      *
      * se non si vuole il cliccare sull'intestazione di una colonna
      * scateni l'ordinamento
      *   INVOKE aControl "NoSortHeader"
      *
      * se non ri vuole che venga selezionata tutta la riga ma solo
      * il primo campo togliere la seguente
          INVOKE aControl "FullRowselect"
      *
          INVOKE aControl "HeaderDragDrop"
      *
          INVOKE aControl "wantAllKeys" *> allows CR to act as Accepted
          INVOKE aControl "keyboardgroup"

          IF CheckBoxesWanted
             INVOKE aControl "CheckBoxes"
          END-IF
          IF IconsWanted
             PERFORM SetupImages
          END-IF

      *   Update the master field with the object reference for the
      *   created control
          SET EntryObject-Reference TO aControl
          SET aListView TO aControl
          IF aControl NOT = NULL
             PERFORM Register-Callbacks
             INVOKE aControl "accessSystemEvents"
          END-IF

          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Resize-Entry-Point Section.
       Entry "R" & ProgramID USING EntryPoint-Data.

      *   When screenset Dynamic resizing is enabled, this entry point
      *   is called by Dialog System runtime when a Window resized event
      *   occurs.

      *   The Dialog System runtime calls this entry point setting
      *   EntryWindow-Data to 0 and then calls it again with
      *   EntryWindow-Data set to 1.

          SET aControl TO EntryObject-Reference
          PERFORM Resize-Routine

          EXIT PROGRAM
          .

       Register-Callbacks section.

          MOVE '"' & ProgramID & z'ItemAccepted"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-Accept TO i
          INVOKE aControl "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>
       *> Functionkeys to pick up CR for Accepted event.
          MOVE '"' & ProgramID & z'ItemFunctionKey"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                  RETURNING aCallback
          MOVE p2ce-DataKey TO i
          INVOKE aControl "setEvent"  USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>
          MOVE '"' & ProgramID & z'ItemDataKey"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                  RETURNING aCallback
          MOVE p2ce-FunctionKey TO i
          INVOKE aControl "setEvent"  USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>
          MOVE '"' & ProgramID & z'ItemSelected"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-select TO i
          INVOKE aControl "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>
          MOVE '"' & ProgramID & z'RightClick"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-button3ClkonItem  TO i
          INVOKE aControl  "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
      **> 
          MOVE '"' & ProgramID & z'Columnclicked"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-clicked  TO i
          INVOKE aControl  "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
          MOVE '"' & ProgramID & z'BeginDrag"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-BeginDrag  TO i
          INVOKE aControl  "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>
          IF CheckBoxesWanted
             MOVE '"' & ProgramID & z'CheckClicked"' TO MessageName
             INVOKE EntryCallback "new" USING MessageName
                                    RETURNING aCallback
             MOVE p2ce-ValueChanged TO i
             INVOKE aControl  "setEvent" USING i aCallback
             INVOKE aCallback "finalize" RETURNING aCallback
          END-IF
       *>
          IF Paging-Data
             MOVE ScrollingList TO MessageName
             INVOKE EntryCallback "new" USING MessageName
                                    RETURNING aCallback
             MOVE p2ce-vertTrack  TO i
             INVOKE aControl  "setEvent" USING i aCallback

             MOVE p2ce-vertEnd   TO i
             INVOKE aControl  "setEvent" USING i aCallback
             INVOKE aCallback "finalize" RETURNING aCallback
          END-IF
       *>
          MOVE '"' & ProgramID & z'Systemkey"' TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          MOVE p2ce-Systemkey TO i
          INVOKE aControl "setEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback
       *>


       *> Always register a callback to delete the dictionary item
       *> when the containing window is deleted.
          MOVE '"' & ProgramID & z'OnDestroyed"' TO MessageName
          INVOKE EntryCallBack "new" USING MessageName
                                 RETURNING aCallback
          MOVE P2Ce-Destroyed TO i
          INVOKE aControl "SetEvent" USING i aCallback
          INVOKE aCallback "finalize" RETURNING aCallback

          PERFORM SaveDataBlockPointer
          .

      *>----------------------------------------------------------------
       Item-Selected section.
       Entry ProgramID & "ItemSelected" USING anEvent.

          PERFORM GetDataBlockPointer

          *> Could use aListViewItem returned from the getSelectedItem
          *> method (as in the Item-Accepted code below), but this code
          *> demonstrates compatibility for multiple selection lists.

          *> Setup a callback to process all items in the Collection of
          *> selected listview items
          MOVE ProcessItem TO MessageName
          INVOKE EntryCallback "new" USING MessageName
                                 RETURNING aCallback
          INVOKE aControl "selectedItems" returning aCollection


          *> TO DO: User defined value to co-ordinate with the other events
          *> to be posted and the screenset window dialog USER-EVENT
          MOVE 34591  TO Event-Type

          *> ProcessItem is called for each selected item
          INVOKE aCollection "do" using aCallback
          INVOKE aCallback "Finalize" RETURNING aCallback
          INVOKE aCollection "finalize" RETURNING aCollection

          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Item-Accepted section.
       Entry ProgramID & "ItemAccepted" USING anEvent.

          PERFORM GetDataBlockPointer
          INVOKE anEvent "getSelectedItem" RETURNING aListViewItem

          *> TO DO: User defined value to co-ordinate with the other events
          *> to be posted and the screenset window dialog USER-EVENT
          MOVE 34592  TO Event-Type
          CALL ProcessItem USING aListViewItem


          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Item-RightClick section.
       Entry ProgramID & "RightClick" USING anEvent.

          PERFORM GetDataBlockPointer
          INVOKE anEvent "getSelectedItem" RETURNING aListViewItem
      *
          *> TO DO: User defined value to co-ordinate with the other events
          *> to be posted and the screenset window dialog USER-EVENT
          MOVE 34593  TO Event-Type
          CALL ProcessItem USING aListViewItem

          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Item-CheckBoxChanged section.
       Entry ProgramID & "CheckClicked" USING anEvent.

          PERFORM GetDataBlockPointer
          IF CheckBoxesWanted

              INVOKE anEvent "getSelectedItem" RETURNING aListViewItem
              IF aListViewItem NOT = NULL
                 INVOKE aListViewItem "class" RETURNING aClass
                 IF aClass = ListViewItem
                    INVOKE aListViewItem "getCheckBoxValue"
                                                   RETURNING itemCBState
                 END-IF
              END-IF
          END-IF

          *> TO DO: Update processing if required based on itemCBState
          *>        0/1 unselected/selected
          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Function-Key-On section.
       Entry ProgramID & "Systemkey" USING anEvent.

          PERFORM GetDataBlockPointer
          INVOKE anEvent "getCharacterCode" RETURNING K-Key OF Keystroke

.     *   display K-KeyAsNum
      *
      * ALT+a 097 ALT+A = 065
          IF k-keyasnum = 065 MOVE 097 TO K-KeyAsNum end-if
      * ALT+b 098 ALT+B = 066
          IF k-keyasnum = 066 MOVE 098 TO K-KeyAsNum end-if
      * ALT+c 099 ALT+C = 067
          IF k-keyasnum = 067 MOVE 099 TO K-KeyAsNum end-if
      * ALT+d 100 ALT+D = 068
          IF k-keyasnum = 068 MOVE 100 TO K-KeyAsNum end-if
      * ALT+e 101 ALT+E = 069
          IF k-keyasnum = 069 MOVE 101 TO K-KeyAsNum end-if
      * ALT+f 102 ALT+F = 070
          IF k-keyasnum = 070 MOVE 102 TO K-KeyAsNum end-if
      * ALT+g 103 ALT+G = 071
          IF k-keyasnum = 071 MOVE 103 TO K-KeyAsNum end-if
      * ALT+h 104 ALT+H = 072
          IF k-keyasnum = 072 MOVE 104 TO K-KeyAsNum end-if
      * ALT+i 105 ALT+I = 073
          IF k-keyasnum = 073 MOVE 105 TO K-KeyAsNum end-if
      * ALT+j 106 ALT+J = 074
          IF k-keyasnum = 074 MOVE 106 TO K-KeyAsNum end-if
      * ALT+k 107 ALT+K = 075
          IF k-keyasnum = 075 MOVE 107 TO K-KeyAsNum end-if
      * ALT+l 108 ALT+L = 076
          IF k-keyasnum = 076 MOVE 108 TO K-KeyAsNum end-if
      * ALT+m 109 ALT+M = 077
          IF k-keyasnum = 077 MOVE 109 TO K-KeyAsNum end-if
      * ALT+n 110 ALT+N = 078
          IF k-keyasnum = 078 MOVE 110 TO K-KeyAsNum end-if
      * ALT+o 111 ALT+O = 079
          IF k-keyasnum = 079 MOVE 111 TO K-KeyAsNum end-if
      * ALT+p 112 ALT+P = 080
          IF k-keyasnum = 080 MOVE 112 TO K-KeyAsNum end-if
      * ALT+q 113 ALT+Q = 081
          IF k-keyasnum = 081 MOVE 113 TO K-KeyAsNum end-if
      * ALT+r 114 ALT+R = 082
          IF k-keyasnum = 082 MOVE 114 TO K-KeyAsNum end-if
      * ALT+s 115 ALT+S = 083
          IF k-keyasnum = 083 MOVE 115 TO K-KeyAsNum end-if
      * ALT+t 116 ALT+T = 084
          IF k-keyasnum = 084 MOVE 116 TO K-KeyAsNum end-if
      * ALT+u 117 ALT+U = 085
          IF k-keyasnum = 085 MOVE 117 TO K-KeyAsNum end-if
      * ALT+v 118 ALT+V = 086
          IF k-keyasnum = 086 MOVE 118 TO K-KeyAsNum end-if
      * ALT+w 119 ALT+W = 087
          IF k-keyasnum = 087 MOVE 119 TO K-KeyAsNum end-if
      *
      * ALT+x 120 ALT+X = 088
          IF k-keyasnum = 088 MOVE 120 TO K-KeyAsNum end-if
      * ALT+y 121 ALT+Y = 089
          IF k-keyasnum = 089 MOVE 121 TO K-KeyAsNum end-if
      *
      * ALT+z 122 ALT+Z = 090
          IF k-keyasnum = 090 MOVE 122 TO K-KeyAsNum end-if
      *
          COMPUTE Event-Type = 33000 + K-KeyAsNum
          CALL ProcessItem USING aListViewItem
      *
          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Function-Key-On-Item section.
       Entry ProgramID & "ItemFunctionKey" USING anEvent.

          PERFORM GetDataBlockPointer
          INVOKE anEvent "getCharacterCode" RETURNING K-Key OF Keystroke

.     *   display K-KeyAsNum
          EVALUATE K-KeyAsNum
          WHEN OVK-RETURN
             *> Is a CR/Enter
             *> TO DO: User defined value to co-ordinate with the other events
             *> to be posted and the screenset window dialog USER-EVENT
             MOVE 34592  TO Event-Type
             CALL ProcessItem USING aListViewItem
          WHEN OVK-TAB
             MOVE 34595  TO Event-Type
             PERFORM Post-User-Event-Routine
      *      PERFORM SetNextFocus
          WHEN OVK-ESCAPE
             MOVE 34596  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F3
             MOVE 34597  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F6
             MOVE 34598  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F4
             MOVE 34600  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-PRIOR
      *
      **** rel 7.1
      * CTRL+A
          WHEN 001
             MOVE 34281  TO Event-Type
             PERFORM Post-User-Event-Routine
      * CTRL+B
          WHEN 002
             MOVE 34282  TO Event-Type
             PERFORM Post-User-Event-Routine
      ************
      * CTRL+C
          WHEN 003
             MOVE 34283  TO Event-Type
             PERFORM Post-User-Event-Routine
      * CTRL+D
          WHEN 004
             MOVE 34284  TO Event-Type
             PERFORM Post-User-Event-Routine
      **** rel 7.1
      * CTRL+S
          WHEN 019
             MOVE 34299  TO Event-Type
             PERFORM Post-User-Event-Routine
      ************
      * CTRL+T
          WHEN 020
             MOVE 34300  TO Event-Type
             PERFORM Post-User-Event-Routine
      *
          WHEN OVK-NEXT
             IF Paging-Data
                CALL ScrollingList USING anEvent
             END-IF
          END-EVALUATE

          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Data-Key-On-Item section.
       Entry ProgramID & "ItemDataKey" USING anEvent.

          PERFORM GetDataBlockPointer
          INVOKE anEvent "getCharacterCode" RETURNING K-Key OF Keystroke

          EVALUATE K-KeyAsNum
          WHEN OVK-RETURN
             *> Is a CR/Enter
             *> TO DO: User defined value to co-ordinate with the other events
             *> to be posted and the screenset window dialog USER-EVENT
             MOVE 34592  TO Event-Type
             CALL ProcessItem USING aListViewItem
          WHEN OVK-TAB
             MOVE 34595  TO Event-Type
             PERFORM Post-User-Event-Routine
      *      PERFORM SetNextFocus
          WHEN OVK-ESCAPE
             MOVE 34596  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F3
             MOVE 34597  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F6
             MOVE 34598  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-F4
             MOVE 34600  TO Event-Type
             PERFORM Post-User-Event-Routine
          WHEN OVK-PRIOR
          WHEN OVK-NEXT
             IF Paging-Data
                CALL ScrollingList USING anEvent
             END-IF
          END-EVALUATE

          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       BeginDrag Section.
       Entry ProgramID & "BeginDrag" USING anEvent.

          INVOKE anEvent "getObject" RETURNING aControl
          INVOKE aControl "getAncestor" RETURNING aWindow

          PERFORM GetDataBlockPointer

          INVOKE anEvent "getSelectedItem" RETURNING lv-object-reference
       *> Now dragging a ListViewItem object


       *> Update the Data Block to indicate a DRAG in progress then post a
       *> USER-EVENT to the screenset, which should change the pointer shape
       *> to a 'dragging' image.

       *> Then, Using the MOUSE-EVENT on Window dialog, test for EVENT-DATA
       *> set to 2, (button 1 up on item) this then detects the DROP on a
       *> GUI item. If the flag is set, populate data in the dropped object
       *> as required using the available datablock settings

          MOVE 1 TO LVDrag-In-Progress

          MOVE 34570 TO Event-Type
          PERFORM Post-User-Event-Routine
          EXIT PROGRAM
          .

      *>----------------------------------------------------------------
       Scrolling section.
       Entry ProgramID & "VerticalScroll" USING anEvent.

          *> User has scrolled the list, check whether we need to
          *> Change the lview-data group
          PERFORM GetDataBlockPointer

          INVOKE aControl "getListViewTopItem"
                                      RETURNING lv-Numeric-Value
          INVOKE aControl "getCountPerPage" RETURNING i

          IF (lv-Numeric-Value + i) > lvData-Max
             *> TO DO: insert code that forces return to input/Output
             *> module to populate more data in the grid
             display "need more data"
          END-IF

          EXIT PROGRAM.

      *>----------------------------------------------------------------
       Process-An-Item section.
       Entry ProgramID & "ProcessItem" USING aListViewItem.

      *   This ListView Item has been selected/accepted/rightclicked

          SET ADDRESS OF Data-Block TO DataBlock-Pointer

          INVOKE aControl "size" RETURNING lv-Numeric-Value
          IF lv-Numeric-Value = 0
             EXIT PROGRAM
          END-IF

          INVOKE aControl "numberOfColumns" RETURNING NumColumns

          *> Get all text from all columns into the datablock
          PERFORM VARYING i FROM 1 BY 1 UNTIL i > NumColumns
             INVOKE aListViewItem "getColumnValue" USING i
                                            RETURNING aCharArray
             MOVE SPACES TO lvItem-Text(i)
             INVOKE aCharArray "getValue" RETURNING lvItem-Text(i)
             INVOKE aCharArray "finalize" RETURNING aCharArray
          END-PERFORM

       *> TO DO: This code posts a USER-EVENT based on the the
       *> Event-Type (Set in the calling sections). You may wish to take
       *> take other actions for the ListItem currently being processed.

          SET lv-Object-Reference  TO aListViewItem
          INVOKE aControl "indexOf" USING aListViewItem
                                RETURNING lv-Numeric-Value
          PERFORM Post-User-Event-Routine

          IF Event-Type = 34592 *> item-accepted - check the checkbox
          AND CheckboxesWanted
             INVOKE aListViewItem "selectCheckBox"
          END-IF

          EXIT PROGRAM
          .

       Insert-Item section.

          INVOKE aControl "numberOfColumns" RETURNING NumColumns

      *   Add a listViewitem (row) using the LView-Item table entries.
          MOVE NumColumns TO NumColumns-x4
          INVOKE ListViewItem "new" USING NumColumns-x4
                                RETURNING aListViewItem
          PERFORM VARYING k from 1 BY 1 UNTIL k > NumColumns
             MOVE lvItem-Text(k) TO Term-Field
             PERFORM Null-Terminate-Routine
             INVOKE aListViewItem "setColumnValuez" USING k
                                                          Term-Field
          END-PERFORM

          IF IconsWanted
             INVOKE aListViewItem "setImageIndex" USING lv-Numeric-Value
          END-IF
      * inserisce in fondo
          IF LVITEM-DOVE NOT = 'P'
             INVOKE aControl "addItem" USING aListViewItem
      * inserisce in testa riga
          ELSE
             INVOKE aControl "insertitem" USING 0 aListViewItem
          end-if
      *
          move aListViewItem to LVDATA-OBJECT
      *
          .

       Insert-Many-Items section.

      *   PERFORM VARYING l FROM 1 BY 1 UNTIL l > lvData-Max
      *      IF IconsWanted
      *         *> if using icons, lvData-Icon holds the imagelist index
      *         MOVE lvData-Icon(l) TO lv-Numeric-Value
      *      END-IF
      *      MOVE lvData-Column1(l) TO lvItem-Text(1)
      *      PERFORM Insert-Item
      *      SET lvData-Object(l) TO aListViewItem
      *   END-PERFORM
          .

       GetOrValidateObject section.

          *> All Called functions that use this section have:

          *> Input: lv-Object-Reference set to the ListView itself AND
          *>        lv-Numeric-Value = Index of the item to work with
          *> OR   : lv-Object-Reference set to the ListViewItem to work
          *>        with AND
          *>        lv-Numeric-Value = 0

          IF lv-Numeric-Value = 0
             *> Request to use an object, test its a valid ListViewItem
             INVOKE lv-Object-Reference "class" RETURNING aClass
             IF aClass NOT = ListViewItem
                MOVE h"FFFFFFFF" TO lv-Numeric-Value
                GO TO List-Program-Exit
             ELSE
                *> valid, get the parent object of this listviewitem
                *> and continue with the required function
                INVOKE lv-Object-Reference "getAncestor" 
                                                 RETURNING aControl
                EXIT SECTION
             END-IF
          END-IF

          *> Retrieve the ListViewItem object using supplied index
          INVOKE aControl "itemAtIndex" USING lv-Numeric-Value
                                    RETURNING lv-Object-Reference
          .

       Add-List-Header section.
      *   Note: The Font is used to determine the column width
      *   MOVE "MS Sans Serif" TO lv-IO-Text-Buffer
      *   MOVE 8 TO pointSize
      *
          MOVE 'DSFNTENV' TO G-VAR
          CALL 'rgenv' USING PARG
          MOVE G-RET TO FNTENV
      *
          MOVE "Arial" TO lv-IO-Text-Buffer
          MOVE 9 TO pointSize
          IF FNTENV = '800x600CP'
             MOVE 7 TO pointSize
          END-IF
          IF FNTENV = '800x600CG'
             MOVE 6 TO pointSize
          END-IF
          IF FNTENV = '1024x768CG'
             MOVE 6 TO pointSize
          END-IF
      *
          MOVE 0 TO AttributeFlags
          PERFORM Set-Font-Function

          MOVE lv-Numeric-Value TO NumColumns
          PERFORM VARYING k from 1 BY 1 UNTIL k > NumColumns
             MOVE lvItem-Text(k) TO Term-Field
             PERFORM Null-Terminate-Routine

             *> Returns a ListViewHeaderItem object
             INVOKE aControl "addColumnz" USING Term-Field
                                    RETURNING lvItem-Object(k)

      *      Work out the required column width from the supplied data
      *      length and the full text extent using the current font

             *> first ensure always big enough for the header text...
             IF lvItem-Length(k) NOT < i
                MOVE lvItem-Length(k) TO i
             END-IF

             *> If required, impose a maximum # of characters, this aids
             *> readability - the column can be enlarged if user wants
             IF i > 19
                MOVE 19 TO i
             END-IF

             MOVE ALL "W" TO Term-Field(1:i)
             INVOKE CharacterArray "withLengthValue" USING i
                                                           Term-Field
                                                 RETURNING aCharArray
             *> get width of (i * "W")
             INVOKE aFont "ObjectTextExtent" USING aCharArray
                                                   text-Width
                                                   text-Height
             *> to get Panels2Genericcoordinates...
             INVOKE aControl "scaleXYUp" USING text-Width
                                               text-Height
             INVOKE aChararray "finalize" RETURNING aCharArray
             IF IconsWanted
             AND CheckBoxesWanted
             AND k = 1  *> make 1st column a bit bigger
                ADD 50 TO text-Width
             ENd-If
      **** calcolo larghezza
             compute text-Width = lvItem-Length(k) * 40
             if lvItem-Length(k) = 1 MOVE 90 TO text-Width end-if
      **********
             INVOKE lvItem-Object(k) "setWidth" USING text-Width

             *> TO DO: insert your own criteria for rightjustified column
      * a destra
             IF lvitem-allin(k) = 1
                INVOKE lvItem-Object(k) "rightJustified"
             END-IF
      * centrato
             IF lvitem-allin(k) = 2
                INVOKE lvItem-Object(k) "centered"
             END-IF

           INVOKE aControl "setColumnFormat" using k LVITEM-FORMAT(k)
      **** rel 7.1
          MOVE lvItem-Text(k) TO titoli(k)
      ************
          END-PERFORM
          .
      **** rel 7.1
       Update-List-Header section.
          MOVE 'DSFNTENV' TO G-VAR
          CALL 'rgenv' USING PARG
          MOVE G-RET TO FNTENV
      *
          MOVE "Arial" TO lv-IO-Text-Buffer
          MOVE 9 TO pointSize
          IF FNTENV = '800x600CP'
             MOVE 7 TO pointSize
          END-IF
          IF FNTENV = '800x600CG'
             MOVE 6 TO pointSize
          END-IF
          IF FNTENV = '1024x768CG'
             MOVE 6 TO pointSize
          END-IF
      *
          MOVE 0 TO AttributeFlags
      *
          perform Set-Font-Function
          move lv-Numeric-Value to NumColumns
      *
          perform varying k from 1 by 1 until k > NumColumns

             move lvItem-Text(k) to Term-Field

             perform Null-Terminate-Routine

             invoke CharacterArray "fromBuffer"
                   using i
                         Term-Field
                   returning aCharArray

             invoke lvItem-Object(k) "SetLabel"
                   using aCharArray

             invoke aCharArray "finalize"
                   returning aCharArray

      *      Work out the required column width from the supplied data
      *      length and the full text extent using the current font

      *> first ensure always big enough for the header text...

             if lvItem-Length(k) not < i
                move lvItem-Length(k) to i
             end-if

      *> If required, impose a maximum # of characters, this aids
      *> readability - the column can be enlarged if user wants
  
             if i > 19
                move 19 to i
             end-if

             move all "W" TO Term-Field(1:i)

             invoke CharacterArray "withLengthValue"
                   using i
                         Term-Field
                   returning aCharArray

      *> get width of (i * "W")

             invoke aFont "ObjectTextExtent"
                   using aCharArray
                         text-Width
                         text-Height

      *> to get Panels2Genericcoordinates...

             invoke aControl "scaleXYUp"
                   using Text-Width
                         Text-Height

             invoke aChararray "finalize"
                   returning aCharArray

             if IconsWanted
                   and CheckBoxesWanted
                   and k = 1  *> make 1st column a bit bigger
                add 50 to Text-Width
             end-if

      **** calcolo larghezza
             compute text-Width = lvItem-Length(k) * 40
             if lvItem-Length(k) = 1 MOVE 90 TO text-Width end-if
      **********

             invoke lvItem-Object(k) "setWidth"
                   using Text-Width

      *> TO DO: insert your own criteria for rightjustified column

             if k > 2
                invoke lvItem-Object(k) "rightJustified"
             end-if

      * centrato
             IF lvitem-allin(k) = 2
                INVOKE lvItem-Object(k) "centered"
             END-IF

           INVOKE aControl "setColumnFormat" using k LVITEM-FORMAT(k)
          END-PERFORM
          .
      ************

       Set-Font-Function section.

      *   Note that it is the responsibility of the application
      *   to finalize any new fonts created. These fonts should
      *   be finalized when the objects that reference them
      *   are finalized and when setting new fonts on objects.

          *> Create a character array to hold the facename
          *> specified in lv-IO-Text-Buffer.
          MOVE LENGTH OF lv-IO-Text-Buffer TO i
          INVOKE CharacterArray "fromBuffer" USING i
                                                   lv-IO-Text-Buffer
                                         RETURNING aCharArray

          *> Create a new font using the specified facename, point size
          *> and style.
          INVOKE font "new" USING aCharArray     *> Facename
                                  pointSize
                                  AttributeFlags
                        RETURNING aFont
          INVOKE aCharArray "finalize" RETURNING aCharArray

      *   Apply the font to the object
          INVOKE aControl "setFont" USING aFont
          .

       SetUpImages section.

          *> Load the bitmap DLL
          INVOKE CharacterArray "withValue" USING resourceDLL
                                        RETURNING aCharArray
          INVOKE module "new" USING aCharArray
                          RETURNING aResource

          *> Normal images - first set up an ImageList 32*32 in size
          MOVE 32 TO i j
          INVOKE MaskedImageList "new" USING i j
                                   RETURNING normalImageList

          *> add the icons to the imagelist
          MOVE BaseResID TO ResourceID
          PERFORM NumberOfImages TIMES
             ADD 1 TO ResourceID
             INVOKE iconData "fromResource" USING aResource
                                                  ResourceID
                                        RETURNING anIcon
             INVOKE normalImageList "addIcon" USING anIcon
                                          RETURNING i
             INVOKE anIcon "finalize" RETURNING anIcon
          END-PERFORM
          INVOKE aControl "setNormalImages" USING normalImageList

          *> Now repeat for small images - 16 pixels this time
          MOVE 'DSFNTENV' TO G-VAR
          CALL 'rgenv' USING PARG
          MOVE G-RET TO FNTENV
      *
          MOVE 16 TO i j
          IF FNTENV = '800x600CP'
             MOVE 16 TO i j
          END-IF
          IF FNTENV = '800x600CG'
             MOVE 16 TO i j
          END-IF
          INVOKE MaskedImageList "new" USING i j
                             RETURNING smallImageList
          *> add the icons to the imagelist
          MOVE BaseResID TO ResourceID
          PERFORM NumberOfImages TIMES
             ADD 1 TO ResourceID
             INVOKE iconData "fromResource" USING aResource
                                                  ResourceID
                                        RETURNING anIcon
             INVOKE smallImageList "addIcon" USING anIcon
                                         RETURNING i
             INVOKE anIcon "finalize" RETURNING anIcon
          END-PERFORM
          INVOKE aControl "setSmallImages" USING smallImageList
          .

       SetNextFocus section.

          *> This is required because we intercept all functionkeys
          *> for this control, (including TAB) which would
          *> otherwise move focus to the next object in order...
          *> so we must do it ourselves
          INVOKE anEvent "ShiftDepressed" RETURNING aBool
          MOVE aBool TO i

          INVOKE aWindow "getID" RETURNING aHWND
          INVOKE aControl "getID" RETURNING aGadgetHWND
          CALL WAPI "GetNextDlgTabItem" USING BY VALUE aHWND
                                                       aGadgetHWND
                                                       i
                                             RETURNING aNextFocusHWND
          INVOKE window "fromHandle" USING aNextFocusHWND
                                 RETURNING anObject
          INVOKE anObject "setFocus"
          .

       GetWindow-Instance-Routine section.

      *   Use the Correct handle Storage format for getting
      *   the object reference... This is not a new window, just
      *   obtaining an object reference for an existing window

          INVOKE Window "fromHandle" USING aHwnd RETURNING aWindow
          INVOKE aWindow "panels2genericcoordinates"
          .

       Resize-Routine Section.

      *   When screenset Dynamic resizing is enabled, this entry point
      *   code is called by DSGRUN when a Window resized event occurs...
      *   the runtime calculates the correct new co-ordinates
      *   following the resize

      *   The EntryWindow-Data flag is used in this context, as a value
      *   to indicate whether to get or set the rectangle details.
      *   0 = Get/ 1 = Set

          IF EntryWindow-Data = 0

      *      The Dialog System Runtime needs to know the current
      *      coordinates of the object instance so it can apply an
      *      adjustment factor to the values that need to change.
             INVOKE EntryObject-Reference "getRectangle"
                                  USING EntryPosition-X EntryPosition-Y
                                        EntrySize-Width EntrySize-Height
             MOVE EntryPosition-X  TO X
             MOVE EntryPosition-Y  TO Y
             MOVE EntrySize-Width  TO W
             MOVE EntrySize-Height TO H
          ELSE

      *      Invoke the setRectangle method of the object instance to
      *      reset the physical sizes following a window-sized event
             INVOKE EntryObject-Reference "setRectangle"
                                  USING EntryPosition-X EntryPosition-Y
                                        EntrySize-Width EntrySize-Height

             SET ADDRESS OF Data-Block TO EntryDataBlock-Pointer
             INVOKE EntryObject-Reference "numberOfColumns"
                                                 RETURNING NumColumns

             *> Reset the columns to reflect the change in rectangle
             PERFORM VARYING i FROM 1 BY 1 UNTIL i > NumColumns
                INVOKE lvItem-Object(i) "getWidth" RETURNING j
                COMPUTE k = ((EntrySize-Width / W) * j)
                INVOKE lvItem-Object(i) "setWidth" USING k
             END-PERFORM
             INVOKE EntryObject-Reference "invalidate"
          END-IF
          .


       Post-User-Event-Routine section.

      *   The EntryCallback class has an extended method to enable
      *   the posting of a user event to the panels2 module. The Dialog
      *   System USER-EVENT dialog table may then act on this event

          INVOKE EntryCallback "PostP2Event" USING Queue-ID
                                                   aHwnd
                                                   Event-Type
          .

       Null-Terminate-Routine Section.

      *   This section loops back from the end of the field until it
      *   encounters a non space - & puts a null in the right place
      *---The buffer sizes used may require user defined values

          perform termina-null thru ex-termina-null
      **** rel 7.1
          move j to i
      ************
      *
      *   MOVE LENGTH OF lvItem-Text(1) TO j
      *   PERFORM VARYING i FROM j BY -1 UNTIL i = 0
      *        IF Term-Field(i:1) NOT = Spaces
      *        AND NOT = X"00"
      *           ADD 1      TO i
      *           MOVE x"00" TO Term-Field(i:1)
      *           EXIT SECTION
      *        END-IF
      *   END-PERFORM
      *   MOVE x"00" TO Term-Field(j:1)
          .

       SaveDataBlockPointer Section.

      *   Save a pointer to the datablock in a dictionary. This is
      *   so we can get at the correct datablock in the callback code.

      *   I.E. The datablock thats associated with the window on
      *   which an event occurs.

          IF 1stTimeThru

      *      First establish a class for creation of our Association
      *      template. Now PIC X(4) Comp-5 is a class instance
             MOVE 4 TO i
             INVOKE CobolComp5 "newClass" USING i
                                        RETURNING aStorageClass
      *      Now Create an association template using an object
      *      reference and a Pic X(4) Comp-5 data item.
             SET anObject TO NULL
             INVOKE Association "newClass" USING anObject aStorageClass
                                       RETURNING anAssocTemplate

      *      Now create our dictionary (upto 32 items) of associations
             MOVE 32 TO i
             INVOKE Dictionary "ofAssociations" USING anAssocTemplate
                                                      i
                                            RETURNING aDictionary
             SET Not1stTimeThru TO TRUE
          END-IF

      *   Insert the Window/datablock Pointer association into the
      *   dictionary

          SET DataBlock-Pointer TO EntryDatablock-pointer
          INVOKE aDictionary "atPut" USING aWindow DataBlock-Pointer
          .


       GetDataBlockPointer section.

      *   This re-sets this entry point program Datablock variable
      *   to the memory location where we know it exists - the
      *   original location identified by the pointer, retrieved from
      *   our dictionary

      *   Find out which object the event occured on
          INVOKE anEvent "getObject" RETURNING aControl

      *   Determine the window handle that will be used to post the
      *   panels2 events to. GetAncestor returns an object ref for the
      *   window, & we can then get its handle using GetID.
          INVOKE aControl "getAncestor" RETURNING aWindow
          INVOKE aWindow "GetID" RETURNING aHwnd


          INVOKE aDictionary "at" USING aWindow
                              RETURNING DataBlock-Pointer

         SET ADDRESS OF Data-Block TO DataBlock-Pointer
          .

       The-Object-is-Destroyed section.
       Entry ProgramID & "OnDestroyed" USING anEvent.

          IF aFont           NOT = NULL
             INVOKE aFont           "finalize" RETURNING aFont
          END-IF

          IF normalImageList NOT = NULL
             INVOKE normalImageList "finalize"
                                     RETURNING normalImageList
          END-IF

          IF smallImageList  NOT = NULL
             INVOKE smallImageList  "finalize"
                                     RETURNING smallImageList
          END-IF

          INVOKE anEvent "getObject" RETURNING aControl
          INVOKE aControl "getAncestor" RETURNING aWindow
          SET DataBlock-Pointer TO NULL

          INVOKE aDictionary "AtOrNil" USING aWindow
                                RETURNING DataBlock-Pointer
          IF DataBlock-Pointer NOT = NULL
             INVOKE aDictionary "removeKey" USING aWindow
          END-IF
          SET aWindow TO NULL
          EXIT PROGRAM
          .
      *
      *>----------------------------------------------------------------
       Item-columnclicked section.
       Entry ProgramID & "Columnclicked" USING anEvent.
          PERFORM GetDataBlockPointer
      *
          INVOKE aControl "columntobesortedon" RETURNING ncol
          move ncol to lv-column-order
      *
          MOVE 34599  TO Event-Type
      *
          PERFORM Post-User-Event-Routine
          EXIT PROGRAM
          .
      *>----------------------------------------------------------------
        colora-List.
          move lv-lnkred to lnkRed
          move lv-lnkgreen to lnkGreen
          move lv-lnkblue to lnkBlue
          INVOKE color "RGB" using lnkred lnkgreen lnkblue
                                   returning colorobject
          INVOKE aListview "setbackgroundcolor" USING colorObject
          INVOKE aListView "invalidate"
          INVOKE colorObject "finalize" RETURNING colorObject
          .
      *>----------------------------------------------------------------
       termina-null.
      **** rel 7.1
          move 0 TO j.
          IF LVITEM-FORMAT(k) = 'DD/MM/YY' AND Term-Field = space
             MOVE x"00" TO Term-Field(9:1)
             GO TO ex-termina-null.
      ************
          IF Term-Field = SPACE MOVE LOW-VALUE TO Term-Field 
                                go to ex-termina-null.
      *
          MOVE LENGTH OF lvItem-Text(1) TO j.
          move j to lung.
      *
          ADD 1 TO j.
       TERMINA-10.
          SUBTRACT 1 from j.
          IF j = zero go to ex-termina-null.
          IF Term-Field(j:1) not = space 
             if j not = lung 
                ADD 1      TO j
                MOVE x"00" TO Term-Field(j:1)
             end-if
             go to ex-termina-null.
          go to TERMINA-10.
       ex-termina-null.
      **** rel 7.1
          exit.
      ************
      *>----------------------------------------------------------------
       riordina.
          IF lv-column-order NOT = ZERO
               move lv-column-order to ncol
               move 1 to comodo
               INVOKE aListView "sortOnColumn" USING ncol comodo.
       ex-riordina.
      **** rel 7.1
          exit.
      *>----------------------------------------------------------------
       scrivi-clipbrd.
          move 1 to ix.
          move low-value to buffer.
      *
      *> verifico il numero di righe
          INVOKE aControl "size" RETURNING lv-Numeric-Value.
          IF lv-Numeric-Value = 0 go to ex-scrivi-clipbrd.
          move lv-numeric-value to nlines.
      *
      *> esportazione titoli colonne
          perform scrivi-tit thru ex-scrivi-tit.

      *> scorro tutte le righe
          move zero to lx.
       scrivi-clipbrd-10.
          add 1 to lx.
          if lx > nlines go to scrivi-clipbrd-99.
      *
      *> esportazione riga
          move lx to lv-numeric-value.
          PERFORM GetOrValidateObject.
          SET aControl-lines TO lv-Object-Reference.
          perform scrivi-riga thru ex-scrivi-riga.
      *
          go to scrivi-clipbrd-10.
       scrivi-clipbrd-99.
      * prendo il contenuto di buffer per aggiornare il puntatore
      * aCharArray
          INVOKE CharacterArray "withValue" USING buffer(1:ix)
                                        RETURNING aCharArray.
      * scrivo su clipboard
          INVOKE clipbrd "write" USING aCharArray.
       ex-scrivi-clipbrd.
          exit.
      *>----------------------------------------------------------------
       scrivi-riga.
          PERFORM VARYING jx FROM 3 BY 1 UNTIL jx > NumColumns
             INVOKE aControl-lines "getColumnValue" USING jx
                                            RETURNING aCharArray
      *
             MOVE SPACES TO lvItem-Text(jx)
             INVOKE aCharArray "getValue" RETURNING lvItem-Text(jx)
             INVOKE aCharArray "finalize" RETURNING aCharArray
             MOVE lvItem-Text(jx) TO Term-Field
             PERFORM Null-Terminate-Routine
             IF LVITEM-FORMAT(jx) = 'NUMERICO' AND j not = zero 
                perform togli-space thru ex-togli-space
             end-if
             IF LVITEM-FORMAT(jx) = 'NUMSEGNO' AND j not = zero 
                perform togli-space thru ex-togli-space
             end-if
             if j not = zero
                subtract 1 from j
                move Term-Field to buffer(ix:j)
                add j to ix
             end-if
             move TAB to buffer(ix:1)
             add 1 to ix
          END-PERFORM.
      * tolgo l'ultimo tab
          subtract 1 from ix.
          MOVE x'0D' TO buffer(ix:1).
          add 1 to ix.
          MOVE x'0A' TO buffer(ix:1).
          add 1 to ix.
       ex-scrivi-riga.
          exit.
      *>----------------------------------------------------------------
       scrivi-tit.
          PERFORM VARYING k FROM 3 BY 1 UNTIL k > NumColumns
             MOVE titoli(k) TO Term-Field
             PERFORM Null-Terminate-Routine
             if j not = zero
                subtract 1 from j
                move Term-Field to buffer(ix:j)
                add j to ix
             end-if
             move TAB to buffer(ix:1)
             add 1 to ix
      *
          END-PERFORM.
      * tolgo l'ultimo tab
          subtract 1 from ix
          MOVE x'0D' TO buffer(ix:1).
          add 1 to ix.
          MOVE x'0A' TO buffer(ix:1).
          add 1 to ix.
       ex-scrivi-tit.
          exit.
      *>----------------------------------------------------------------
       scrivi-clipbrd-line.
          move 1 to ix.
          move low-value to buffer.
      *
      *> esportazione titoli colonne
          perform scrivi-tit thru ex-scrivi-tit.
      *
          SET aControl-lines TO aListViewItem.
          perform scrivi-riga thru ex-scrivi-riga.
      *
          INVOKE CharacterArray "withValue" USING buffer(1:ix)
                                        RETURNING aCharArray.
      * scrivo su clipboard
          INVOKE clipbrd "write" USING aCharArray.
       ex-scrivi-clipbrd-line.
          exit.
      *>----------------------------------------------------------------
       togli-space.
          move space to flgsegno.
          move 0 to sx.
      *
          move 1 to cx.
          perform until Term-Field(cx:1) = low-value
              if Term-Field(cx:1) = '-' OR '+' 
      * il segno  dietro
                 if sx not = zero
                    move Term-Field(cx:1) to flgsegno
                 end-if
              end-if
              if Term-Field(cx:1) not = space and 
                 Term-Field(cx - 1:1) = space
                 move cx to sx
              end-if
              add 1 to cx
          end-perform.
      * devo spostare il segno
          if flgsegno not = space
             move flgsegno to comodox(1:1)
             move Term-Field(sx:) to comodox(2:)
          else
             move Term-Field(sx:) to comodox.
      *
          subtract 1 from sx
          move comodox to Term-Field.
      *
          subtract sx from i j.
       ex-togli-space.
          exit.
      *>----------------------------------------------------------------
       ini-esporta.
          move 1 to ix.
          MOVE ZERO       TO PARELV.
          MOVE SPACE      TO PELV-TITOLI.
          MOVE SPACE      TO PELV-FORMATI.
          MOVE SPACE      TO PELV-DATI.
          MOVE NumColumns TO PELV-NCOL.
      * tolgo icona e numeratore riga
          SUBTRACT 2 FROM PELV-NCOL.
          PERFORM VARYING k FROM 3 BY 1 UNTIL k > NumColumns
             MOVE titoli(k)        TO PELV-TITOLO(ix)
             MOVE LVITEM-FORMAT(k) TO PELV-FORMAT(ix)
             add 1 to ix
          END-PERFORM.
      *
          MOVE LV-NPGM   TO PELV-NPGM.
          MOVE 'I'       TO PELV-FUN.
          CALL 'vrlvexp' USING PARELV PARXP.
       ex-ini-esporta.
          exit.
      *>----------------------------------------------------------------
       esporta.
      *> verifico il numero di righe
          INVOKE aControl "size" RETURNING lv-Numeric-Value.
          IF lv-Numeric-Value = 0 go to ex-scrivi-clipbrd.
          move lv-numeric-value to nlines.
      *
      *> scorro tutte le righe
          move zero to lx.
       esporta-10.
          add 1 to lx.
          if lx > nlines go to esporta-99.
      *
      *> esportazione riga
          move lx to lv-numeric-value.
          PERFORM GetOrValidateObject.
          SET aControl-lines TO lv-Object-Reference.
      *
          perform esporta-riga thru ex-esporta-riga.
      *
          go to esporta-10.
       esporta-99.
          MOVE 'C'       TO PELV-FUN.
          CALL 'vrlvexp' USING PARELV PARXP.
       ex-esporta.
          exit.
      *>----------------------------------------------------------------
       esporta-riga.
          move 1 to ix.
          MOVE SPACE      TO PELV-DATI.
          PERFORM VARYING jx FROM 3 BY 1 UNTIL jx > NumColumns
             INVOKE aControl-lines "getColumnValue" USING jx
                                            RETURNING aCharArray
      *
             MOVE SPACES TO lvItem-Text(jx)
             INVOKE aCharArray "getValue" RETURNING lvItem-Text(jx)
             INVOKE aCharArray "finalize" RETURNING aCharArray
             MOVE lvItem-Text(jx) TO PELV-DATO(ix)
             PERFORM Null-Terminate-Routine
             add 1 to ix
          END-PERFORM.
          MOVE 'E'       TO PELV-FUN.
          CALL 'vrlvexp' USING PARELV PARXP.
       ex-esporta-riga.
          exit.
      *>----------------------------------------------------------------
      ************
