       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRXCZT. 
      *
      **** rel 6.3
      * nuovo: gestione Archivi con List-view
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gricztsl'.   
       DATA DIVISION.
       FILE SECTION.
           COPY 'griczt'.    
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parzf'.
           COPY 'parmc'.
           COPY 'parcdt'.
       01  ID-CZT  PIC X(50) VALUE 'cfgzot'.
       01  SF-CZT  PIC XX.
       01  AREE.
           05 MESS    PIC X(40).
           05 FUN     PIC X.
           05 IDX     PIC 9.
           05 SEZ     PIC 9.
           05 NUM     PIC 999.
           05 NUMC    PIC 999.
           05 EOF     PIC 9.
           05 LETTI   PIC 999.
           05 RIGRIF  PIC 999.
           05 NR      PIC 999.
           05 K1      PIC 999.
           05 KMAX    PIC 999   VALUE ZERO.
           05 TABK OCCURS 100.
              10 TABKC PIC X(10).
              10 TABKA PIC 999.
              10 TABKU PIC X(10).
           05 KRIFER  PIC X(50).
           05 LNSEZ   PIC 999.
           05 INCR    PIC S9.
           05 LF      PIC X     VALUE X'0A'.
           05 SWTROVA PIC 9.
           05 Y1      PIC 99.
           05 IND     PIC 99.

       LINKAGE SECTION.
           COPY 'gricztrx'.
       01  IF-BUFF.
           05 SEZ1.
              10 RIG1 OCCURS 100.
                 15 COD1    PIC X(10).
                 15 FILLER  PIC X.
                 15 AZI1    PIC ZZZ.
                 15 FILLER  PIC X.
                 15 UTE1    PIC X(10).
                 15 FILLER  PIC X.
                 15 DES1    PIC X(60).
                 15 FILLER  PIC X.
                 15 LF1     PIC X.
       01  IF-MESS    PIC X(204).

       PROCEDURE DIVISION USING GS-CZT-SHARED
                                RX-CZT-CTRL
                                IF-BUFF
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclczt'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-CZT-ST RX-CZT-LETTI RX-CZT-NBYTE.
           MOVE SPACE TO IF-MESS.
           MOVE GS-CZT-FUN TO FUN.
      *
      * funzioni che trattano record
           IF FUN = 'X'
              PERFORM CONTROLLA-POS
              MOVE ZERO TO GS-CZT-SEL
              MOVE TABKC(RX-CZT-POS) TO GS-CZT-COD
              MOVE TABKA(RX-CZT-POS) TO GS-CZT-AZI
              MOVE TABKU(RX-CZT-POS) TO GS-CZT-UTE
              GO TO ESCI.
      *       
           IF FUN NOT = 'Z' MOVE ZERO TO RX-CZT-EOF.
      *
      * funzioni che restituiscono buffer
           MOVE ZERO  TO RX-CZT-POS.
           MOVE GS-CZT-IDX TO IDX.
           MOVE GS-CZT-SEZ TO SEZ.
           MOVE RX-CZT-NUM TO NUM.
           IF FUN = 'F' OR 'L' OR 'C'
              MOVE ZERO TO SWTROVA.
           IF FUN = 'K'
              MOVE 1   TO SWTROVA
              MOVE 'F' TO FUN.
           IF SWTROVA > ZERO MOVE 20  TO NUM.
           IF NOT (FUN = 'F' OR 'L' OR 'C' OR 'B' OR 'T' OR 'Z')
              MOVE 'F' TO FUN.
           IF (FUN = 'B' OR 'T' OR 'Z') PERFORM CONTROLLA-KMAX.
      *    IF NOT (IDX = 1 OR 2) MOVE 1 TO IDX.
           MOVE 1 TO IDX.
           MOVE 1 TO SEZ.
           IF NUM = ZERO MOVE 80   TO NUM.
           IF FUN = 'T'  MOVE 1    TO RIGRIF.
           IF FUN = 'B'  MOVE KMAX TO RIGRIF.
           IF FUN = 'T' OR 'L'
              MOVE NUM TO NR
           ELSE
              MOVE 1   TO NR.
           MOVE NUM TO NUMC.
           IF FUN = 'C' COMPUTE NUMC = NUM / 2 + 1.

      **** rel 7.1
           MOVE 'cfgzot' TO ID-CZT.
           IF NOT (EX-DFL = SPACE OR LOW-VALUE) AND
              NOT (EX-FL = SPACE OR LOW-VALUE)
                 MOVE SPACE TO ID-CZT
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzot'
                        INTO ID-CZT.
      ************
           OPEN INPUT CFGZOT.
           IF FUN = 'Z' PERFORM CAMBIA-SEZ THRU EX-CAMBIA-SEZ
                        GO TO QUIT1.
       INI00.
           MOVE ZERO TO EOF LETTI.
           IF FUN = 'T' OR 'L'
              MOVE -1  TO INCR
           ELSE
              MOVE 1   TO INCR.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
           IF EOF > ZERO GO TO ENDATI.

      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYCZT NOT = KRIFER GO TO CERCA.
       CER90.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.

      * carica buffer
       CARBUF.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO ENDATI.
       CARB10.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           IF LETTI >= NUMC GO TO ENDATI.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           GO TO CARBUF.

      * fine ciclo di letture / caricamento buffer
       ENDATI.
           SUBTRACT INCR FROM NR.
           IF FUN = 'F' MOVE 1 TO RX-CZT-EOF.
           IF FUN = 'L' MOVE 3 TO RX-CZT-EOF.
           ADD EOF   TO RX-CZT-EOF.
           ADD LETTI TO RX-CZT-LETTI.
           IF RX-CZT-LETTI = NUM  GO TO QUIT.
           IF RX-CZT-EOF = 4 GO TO ENDBUF.
     
      * incontrato BOF/EOF prima di aver letto NUM records o
      *    funzione C da completare: shift buffer indietro/avanti
      *    e tenta di inserire altri record in coda/testa
           IF RX-CZT-LETTI > ZERO GO TO SHIFT.
           IF FUN = 'T' OR 'L'
              MOVE 'F' TO FUN
              MOVE 1   TO NR
           ELSE
              MOVE 'L' TO FUN
              MOVE NUM TO NR.
           MOVE NUM TO NUMC.
           GO TO INI00.
       SHIFT.
           IF FUN = 'T' OR 'L'
              PERFORM SHIFT-BUF-INDIETRO
              MOVE RX-CZT-LETTI TO RIGRIF
              COMPUTE NR = RIGRIF + 1
              MOVE 'B' TO FUN
           ELSE
              PERFORM SHIFT-BUF-AVANTI
              COMPUTE NR = NUM - RX-CZT-LETTI
              COMPUTE RIGRIF = NR + 1
              MOVE 'T' TO FUN.
           COMPUTE NUMC = NUM - RX-CZT-LETTI.
           GO TO INI00.

      * buffer completato
       ENDBUF.
           IF FUN = 'T' OR 'L' PERFORM SHIFT-BUF-INDIETRO.
           PERFORM BLANK-BUF.

       QUIT.
           MOVE RX-CZT-LETTI TO KMAX.
           IF RX-CZT-EOF = 4 MOVE 2 TO RX-CZT-EOF.
           IF RX-CZT-POS = ZERO
              IF FUN = 'T' OR 'L'
                 MOVE RX-CZT-LETTI TO RX-CZT-POS
              ELSE
                 MOVE 1 TO RX-CZT-POS.
       QUIT1.
           PERFORM LENGTH-SEZ.
           COMPUTE RX-CZT-NBYTE = LNSEZ * RX-CZT-LETTI.
           GO TO FINE.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-CZT-ST.
       FINE.
           CLOSE CFGZOT.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-CZT-ST.
           EXIT PROGRAM.
           COPY 'griczter'.
           COPY 'grixxxer'.
      *--------
       CONTROLLA-KMAX.
           IF KMAX = ZERO
              MOVE 'vrxdte: Funzione non ammessa' TO MESS
              GO TO ERRIO.
      *------------------
       CONTROLLA-POS.
           PERFORM CONTROLLA-KMAX.
           IF RX-CZT-POS = ZERO OR RX-CZT-POS > KMAX
              MOVE 'vrxdte: Parametro POS non corretto' TO MESS
              GO TO ERRIO.
      *------------------
       SHIFT-BUF-INDIETRO.
           IF RX-CZT-POS = ZERO MOVE NUM TO RX-CZT-POS.
           MOVE 1 TO K1.
           PERFORM UNTIL K1 > RX-CZT-LETTI
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              ADD 1 TO K1 NR
           END-PERFORM.
           COMPUTE RX-CZT-POS = RX-CZT-POS - ( NUM - RX-CZT-LETTI ).
      *------------------
       SHIFT-BUF-AVANTI.
           IF RX-CZT-POS = ZERO MOVE 1 TO RX-CZT-POS.
           MOVE NUM TO K1.
           PERFORM UNTIL NR = ZERO
              MOVE RIG1(NR) TO RIG1(K1)
              MOVE TABK(NR) TO TABK(K1)
              SUBTRACT 1 FROM K1 NR
           END-PERFORM.
           COMPUTE RX-CZT-POS = RX-CZT-POS + ( NUM - RX-CZT-LETTI ).
      *------------------
      * pulisce righe buffer non caricate
       BLANK-BUF.
           COMPUTE NR = RX-CZT-LETTI + 1.
           PERFORM UNTIL NR > NUM
              MOVE SPACE TO RIG1(NR)
              ADD 1 TO NR
           END-PERFORM.
      *------------------
       LENGTH-SEZ.
           IF RX-CZT-LETTI = ZERO
              MOVE ZERO TO LNSEZ
           ELSE
              MOVE 1 TO LNSEZ
              PERFORM UNTIL IF-BUFF(LNSEZ:1) = LF ADD 1 TO LNSEZ.
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START CFGZOT KEY <= KEYCZT INVALID MOVE 1 TO EOF
           ELSE
              START CFGZOT KEY >= KEYCZT INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              READ CFGZOT PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ CFGZOT NEXT AT END MOVE 3 TO EOF.
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYCZT.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYCZT.
      * caricamento campi chiave fissi

      * ---
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
      *    IF IDX = 1 MOVE GS-CZT-VAL-1  TO KCZT-COD
      *               MOVE GS-CZT-VAL-1A TO KCZT-AZI
      *               MOVE GS-CZT-VAL-1B TO KCZT-UTE.
           MOVE GS-CZT-VAL-1  TO KCZT-COD.
           MOVE GS-CZT-VAL-1A TO KCZT-AZI.
           MOVE GS-CZT-VAL-1B TO KCZT-UTE.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE TABKC(RIGRIF) TO KCZT-COD.
           MOVE TABKA(RIGRIF) TO KCZT-AZI.
           MOVE TABKU(RIGRIF) TO KCZT-UTE.
           MOVE KEYCZT TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
       TEST-EOL.
           IF RF-CZT = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-CZT = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *
           MOVE SPACE TO MC-STR.
           MOVE 1 TO IND.
      * Cerco i tre indici
           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (CZT-DES1(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO
              STRING CZT-DES1(1:Y1 + 1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.

           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (CZT-DES2(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO
              STRING CZT-DES2(1:Y1 + 1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.

           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (CZT-DES3(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO AND IND < 80
              STRING CZT-DES3(1:Y1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.

      * Stringa di ricerca
           IF SWTROVA > ZERO
              MOVE GS-CZT-VAL-T TO MC-EXP
              CALL 'rmatch' USING PARMC
              IF MC-ST > ZERO GO TO EX-MOVE-REC.
      *
       MOVE-SEZ1.
           MOVE SPACE      TO RIG1(NR).
           MOVE KCZT-COD   TO COD1(NR).
           MOVE KCZT-AZI   TO AZI1(NR).
           MOVE KCZT-UTE   TO UTE1(NR).
           MOVE CZT-DES1   TO DES1(NR).
           GO TO MOVE-END.
       MOVE-END.
           IF SEZ = 1 MOVE LF TO LF1(NR).
           MOVE KCZT-COD TO TABKC(NR).
           MOVE KCZT-AZI TO TABKA(NR).
           MOVE KCZT-UTE TO TABKU(NR).
           ADD 1 TO LETTI.
           ADD INCR TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       CAMBIA-SEZ.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           MOVE ZERO TO K1 LETTI.
           MOVE 1 TO INCR.
       CAMBIA-SEZ-10.
           ADD 1 TO K1.
           IF K1 > KMAX GO TO CAMBIA-SEZ-90.
           MOVE TABKC(K1) TO KCZT-COD.
           MOVE TABKA(K1) TO KCZT-AZI.
           MOVE TABKU(K1) TO KCZT-UTE.
           READ CFGZOT INVALID GO TO CAMBIA-SEZ-10.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           GO TO CAMBIA-SEZ-10.
       CAMBIA-SEZ-90.
           MOVE LETTI TO RX-CZT-LETTI KMAX.
           PERFORM BLANK-BUF.
       EX-CAMBIA-SEZ.
           EXIT.
      *------------------
