       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRXCZR. 
      **** rel 6.3
      * Nuovo: Interfaccia VRXCZR per list box
      ************
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griczrsl'.   
           COPY 'gricztsl'.   
       DATA DIVISION.
       FILE SECTION.
           COPY 'griczr'.    
           COPY 'griczt'.    
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parzf'.
           COPY 'parmc'.
           COPY 'parcdt'.
      *
           COPY 'zoom-v'.
      *
       01  ID-CZR  PIC X(50) VALUE 'cfgzor'.
       01  ID-CZT  PIC X(50) VALUE 'cfgzot'.
       01  SF-CZR  PIC XX.
       01  SF-CZT  PIC XX.
       01  AREE.
           05 NPGMLVIEW PIC X(10) VALUE 'vrxczrl'.
           05 NPGMZOOM  PIC X(10) VALUE 'vrxczr'.
           05 TABK    PIC X(50)  OCCURS 100.
           05 KRIFER    PIC X(50).
      *
           05 Y1      PIC 99.
           05 IND     PIC 99.
           05 IND-I   PIC 999   VALUE ZERO.
           05 IND-F   PIC 999   VALUE ZERO.
           05 K       PIC 9.
           05 COMODO  PIC 999.
      *
           COPY 'vrxczr.cpy'.
       LINKAGE SECTION.
           COPY 'griczrrx'
           REPLACING GS-CZR-AZI    BY GS-AZI
                     GS-CZR-FUN    BY GS-FUN
                     GS-CZR-IDX    BY GS-IDX
                     GS-CZR-SV     BY GS-SV 
                     GS-CZR-SEL    BY GS-SEL
                     RX-CZR-FUN    BY RX-FUN
                     RX-CZR-ST     BY RX-ST
                     RX-CZR-POS    BY RX-POS
                     RX-CZR-NUM    BY RX-NUM
                     RX-CZR-LETTI  BY RX-LETTI
                     RX-CZR-EOF    BY RX-EOF
                     RX-CZR-RG-EOF BY RX-RG-EOF
                     RX-CZR-CAMPO  BY RX-CAMPO.
      *
       01  IF-MESS    PIC X(204).
           COPY 'lview.cpy'.
       PROCEDURE DIVISION USING GS-CZR-SHARED
                                RX-CZR-CTRL
                                RX-CZR-INT
                                IF-MESS
                                DATA-BLOCK.
           COPY 'declxer1'.
           COPY 'dclczr'.
           COPY 'dclczt'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RX-ST RX-RG-EOF
           MOVE SPACE TO IF-MESS.
           MOVE RX-FUN TO FUN.
           MOVE RX-NUM TO NUM.
           MOVE ZERO   TO RX-POS.
           MOVE GS-IDX TO IDX.

      *> parte con il caricamente dello zoom
           COPY 'zoom-i'.
           IF NOT (IDX = 1 OR 2) MOVE 1 TO IDX.
      *
      **** rel 7.1
           MOVE 'cfgzot' TO ID-CZT.
           MOVE 'cfgzor' TO ID-CZR.
           IF NOT (EX-DFL = SPACE OR LOW-VALUE) AND
              NOT (EX-FL = SPACE OR LOW-VALUE)
                 MOVE SPACE TO ID-CZT
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzot'
                        INTO ID-CZT
      *
                 MOVE SPACE TO ID-CZR
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzor'
                        INTO ID-CZR.
      ************
           OPEN INPUT CFGZOR.
           OPEN INPUT CFGZOT.
           PERFORM MOVE-INT THRU EX-MOVE-INT.
       INI00.
           MOVE ZERO TO EOF LETTI.
           PERFORM MOVE-KEY THRU EX-MOVE-KEY.
           IF IDX = 1 PERFORM START-IDX1.
           IF IDX = 2 PERFORM START-IDX2.
           IF EOF > ZERO GO TO ENDATI.
      *
      * cerca primo record nel range richiesto
       CERCA.
           PERFORM READ-N-P.
           IF EOF > ZERO GO TO ENDATI.
           IF FUN = 'F' OR 'L' OR 'C' GO TO CARBUF.
           IF IDX = 1 GO TO CER90.
      *    ( controlla tramite chiave primaria se il record letto da
      *      secondario e' quello richiesto )
           IF KEYCZR NOT = KRIFER GO TO CERCA.
      * 
           COPY 'zoom-r'.
      *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RX-ST.
       FINE.
           CLOSE CFGZOR.
           CLOSE CFGZOT.
       ESCI.
           IF FUN = 'X' OR 'N' OR 'P'
              IF RX-POS NOT = ZERO
              MOVE TABK(RX-POS) TO GS-CZR-FLD.
      *
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RX-ST.
           EXIT PROGRAM.
           COPY 'griczrer'.
           COPY 'griczter'.
           COPY 'grixxxer'.
      *--------
      *------------------
       START-IDX1.
           IF FUN = 'T' OR 'L'
              START CFGZOR KEY <= KEYCZR INVALID MOVE 1 TO EOF
           ELSE
              START CFGZOR KEY >= KEYCZR INVALID MOVE 3 TO EOF.
      *------------------
       START-IDX2.
           IF FUN = 'T' OR 'L'
              START CFGZOR KEY <= SKEYCZR3  INVALID MOVE 1 TO EOF
           ELSE
              START CFGZOR KEY >= SKEYCZR3  INVALID MOVE 3 TO EOF.
      *------------------
       READ-N-P.
           IF FUN = 'T' OR 'L'
              MOVE 'P' TO LVITEM-DOVE
              READ CFGZOR PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              MOVE 'D' TO LVITEM-DOVE
              READ CFGZOR NEXT AT END MOVE 3 TO EOF.
      *------------------
       MOVE-KEY.
           MOVE LOW-VALUE TO KEYCZR SKCZR-NCOLUTE SKCZR-NCOL.
           IF FUN = 'L' MOVE HIGH-VALUE TO KEYCZR 
                                           SKCZR-NCOLUTE SKCZR-NCOL.
      * caricamento campi chiave fissi
           MOVE GS-CZR-COD TO KCZR-COD.
           MOVE GS-AZI     TO KCZR-AZI.
           MOVE GS-CZR-UTE TO KCZR-UTE.
      * ---
           IF FUN = 'C'        GO TO MOVE-KEY-C.
           IF FUN = 'B' OR 'T' GO TO MOVE-KEY-N-P.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-C.
           IF IDX = 1 MOVE GS-CZR-VAL-1  TO KCZR-FLD.
           IF IDX = 2 IF GS-CZR-VAL-2 NOT = 999 ADD 2 TO GS-CZR-VAL-2
                      END-IF
                      MOVE GS-CZR-VAL-2  TO SKCZR-NCOLUTE.
           GO TO EX-MOVE-KEY.
       MOVE-KEY-N-P.
           MOVE TABK(RIGRIF) TO KCZR-FLD.
           MOVE KEYCZR TO KRIFER.
           IF IDX = 1 GO TO EX-MOVE-KEY.
      * acquisizione chiavi secondarie tramite lettura da primario
           READ CFGZOR INVALID MOVE ZERO TO SKCZR-NCOLUTE SKCZR-NCOL.
       EX-MOVE-KEY.
           EXIT.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-CZR = LOW-VALUE GO TO EX-TEST-EOL.
           IF KCZR-COD = GS-CZR-COD AND
              KCZR-AZI = GS-AZI     AND
              KCZR-UTE = GS-CZR-UTE GO TO EX-TEST-EOL.
           IF FUN = 'T' OR 'L'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       EX-TEST-EOL.
           EXIT.
      *------------------
       MOVE-REC.
           IF RF-CZR = LOW-VALUE GO TO EX-MOVE-REC.
      *
      *    ( inserire qui controlli se ci sono records
      *      da escludere prima di incontrare BOF/EOF:
      *      per skip record GO TO EX-MOVE-REC )
      *
           MOVE SPACE TO MC-STR.
           MOVE 1 TO IND.
      * Cerco i tre indici
           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (KCZR-FLD(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO
              STRING KCZR-FLD(1:Y1 + 1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.

           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (CZR-DES1(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO
              STRING CZR-DES1(1:Y1 + 1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.

           MOVE 60 TO Y1.
           PERFORM UNTIL NOT (CZR-INTC(Y1:1) = SPACE) OR Y1 = 0
               SUBTRACT 1 FROM Y1.
           IF Y1 NOT = ZERO AND IND < 80
              STRING CZR-INTC(1:Y1) DELIMITED SIZE
                     INTO MC-STR POINTER IND.


      * Stringa di ricerca
          IF SWTROVA > ZERO
             MOVE GS-CZR-VAL-T TO MC-EXP
             CALL 'rmatch' USING PARMC
             IF MC-ST > ZERO GO TO EX-MOVE-REC.
      *
           MOVE LOW-VALUE    TO RIG1.

           MOVE '08' TO LVDATA-ICON.
           IF CZR-EXP NOT = ZERO MOVE '17'  TO LVDATA-ICON.
      *
           MOVE 'Stringa'   TO TIP.
           IF CZR-TIPO = 1 MOVE 'Numero' TO TIP.
           IF CZR-TIPO = 3 MOVE 'Data' TO TIP.
      *
           MOVE CZR-NCOLUTE TO COMODO.
           IF CZR-NCOLUTE = 999 
              MOVE 0 TO COLO
           ELSE
              SUBTRACT 2 FROM COMODO
              MOVE COMODO TO COLO.
      *
           MOVE CZR-INTC   TO INTC.
           IF CZR-INTC = SPACE MOVE CZR-DES1 TO INTC.
           MOVE LF         TO LF1.
           PERFORM CARICA-LVIEW THRU EX-CARICA-LVIEW.
      *
           GO TO MOVE-END.
       MOVE-END.

           MOVE KCZR-FLD TO TABK(NR).
           ADD 1 TO LETTI.
           IF FUN = 'T' OR 'L'
              MOVE NR TO KMIN
           ELSE
              MOVE NR TO KMAX.
      *
           ADD 1 TO NR.
       EX-MOVE-REC.
           EXIT.
      *------------------
       MOVE-INT.
      * carica dati intestazione
           MOVE SPACE TO RX-CZR-COD-T
                         RX-CZR-DES1-T.
      *
           MOVE GS-CZR-COD     TO KCZT-COD.
           MOVE GS-AZI         TO KCZT-AZI.
           MOVE GS-CZR-UTE     TO KCZT-UTE.
           READ CFGZOT INTO KCZT-COD 
                       INVALID MOVE ALL '*' TO  KCZT-UTE CZT-DES1
                               MOVE 999     TO  KCZT-AZI.
           IF SF-CZT = '9D' OR '9A' OR '35' MOVE RF-CZT TO KCZT-COD .
           MOVE KCZT-COD     TO RX-CZR-COD-T.
           MOVE KCZT-AZI     TO RX-CZR-AZI-T.
           MOVE KCZT-UTE     TO RX-CZR-UTE-T.
           MOVE CZT-DES1     TO RX-CZR-DES1-T.
           GO TO EX-MOVE-INT.
       EX-MOVE-INT.
           EXIT.
      *------------------
       UPDATE-ITEM.
           MOVE LVITEM-TEXT(2)   TO NRIGAX.
           MOVE NRIGA            TO RX-POS FOCUSNR.
           MOVE LV-NUMERIC-VALUE TO PGZ-POSLV.
           PERFORM CONTROLLA-POS.
      *
           OPEN INPUT CFGZOR CFGZOT.
           MOVE GS-CZR-COD TO KCZR-COD.
           MOVE GS-AZI     TO KCZR-AZI.
           MOVE GS-CZR-UTE TO KCZR-UTE.
           MOVE TABK(RX-POS) TO KCZR-FLD.
           READ CFGZOR INVALID PERFORM INVK-CZR
                               GO TO ERRIO.
      *
           MOVE NR            TO SAVNR.
           MOVE PGZ-POSLV     TO LV-NUMERIC-VALUE.
           MOVE FOCUSNR       TO NR.
           PERFORM MOVE-REC THRU MOVE-END.
           CLOSE CFGZOR CFGZOT.
           MOVE SAVNR         TO NR.
       EX-UPDATE-ITEM.
           EXIT.
      *------------------
       INSERT-ITEM.
           OPEN INPUT CFGZOR CFGZOT.
           MOVE GS-CZR-COD TO KCZR-COD.
           MOVE GS-AZI     TO KCZR-AZI.
           MOVE GS-CZR-UTE TO KCZR-UTE.
           MOVE TABK(RX-POS) TO KCZR-FLD.
           READ CFGZOR INVALID PERFORM INVK-CZR
                               GO TO ERRIO.
      *
           MOVE NR TO SAVNR.
      *
           MOVE 'D'       TO LVITEM-DOVE.
           PERFORM MOVE-REC THRU EX-MOVE-REC.
           CLOSE CFGZOR CFGZOT.
           IF NR = SAVNR GO TO EX-INSERT-ITEM.
      *
           MOVE NR TO FOCUSNR.
           SUBTRACT 1 FROM FOCUSNR.
      *
           ADD 1 TO RX-LETTI.
      *
      * sort
           MOVE GS-AZI     TO PGZ-AZI.
           MOVE 'S'        TO PGZ-FUN.
           MOVE NPGMZOOM   TO PGZ-ZOOM.
           MOVE NPGMLVIEW  TO PGZ-NPGM.
           MOVE SPACE      TO PGZ-DATI.
           CALL 'vrgenzom' USING PARGZOOM IF-MESS Data-Block.
      *
           PERFORM SET-FOCUS THRU EX-SET-FOCUS.
       EX-INSERT-ITEM.
           EXIT.
      *------------------
       V-DATI.
      * validazione dei campi filtri
           MOVE ZERO TO VFLD.
      *
           GO TO EX-V-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
       INIZIA-ZOOM.
           MOVE 1 TO LV-ICONSWANTED.
           PERFORM CREA-LVIEW THRU EX-CREA-LVIEW.
       EX-INIZIA-ZOOM.
           EXIT.
      *------------------
      * eventuali dati da aggiornare a seguito cancellazione/inserimento
      * /modifica
      * es. totale documento
       AGG-PIEDE.
       EX-AGG-PIEDE.
           EXIT.
      *------------------
       SAVE-OPZI.
       EX-SAVE-OPZI.
           EXIT.
      *------------------
